{
SpinStruct: Singly Linked List Queue Demo
}

CON
' for prop-protoboard
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
' for spin-stamp
'  _clkmode = xtal1+pll8x
'  _xinfreq = 10_000_000

CON
  HEAPEND       = $7F00
  HEAPSIZE      = $2000

OBJ
  vga   : "VGA_Text"
  q     : "queue"
  m     : "malloc"
  mu    : "malloc_utils"

PUB main
  vga.start(16)
  vga.str(string($d,"queue test "))
  m.init(HEAPEND-HEAPSIZE,HEAPSIZE,2)
  doqueue
  repeat

PUB doqueue | ii, top, ptr
  q.init
  repeat ii from 0 to 3
    q.enqueue(ii)

  vga.str(string($d,"queue size "))
  vga.dec(q.size)
{
  vga.str(string($d,"dequeue 0 "))
  vga.hex(q.dequeue, 4)
  
  vga.str(string($d,"queue size "))
  vga.dec(q.size)
}
  dumpQueue
  
  repeat ii from 0 to 3
    vga.str(string($d,"enqueue "))
    vga.dec(ii)
    q.enqueue(ii)

  vga.str(string($d,"dequeue "))
  vga.hex(q.dequeue, 4)

  vga.str(string($d,"enqueue 4 "))
  q.enqueue(4)

  vga.str(string($d,"dequeue "))
  vga.hex(q.dequeue, 4)
  
  dumpQueue

  vga.str(string($d,"dequeue "))
  vga.hex(q.dequeue, 4)
  

PUB dumpQueue
  repeat
    vga.str(string($d,"dequeue "))
    vga.dec(q.size)
    vga.out(" ")
    vga.hex(q.dequeue, 4)
  while(q.size > 0)
  